package gui;

import javafx.application.Platform;
import javafx.event.ActionEvent;
import javafx.fxml.FXML;
import javafx.fxml.Initializable;
import javafx.scene.control.Button;
import javafx.scene.control.ChoiceBox;
import javafx.scene.control.Label;
import javafx.scene.control.TextField;
import javafx.scene.image.Image;
import javafx.scene.image.ImageView;
import javafx.scene.input.MouseEvent;
import javafx.scene.layout.GridPane;
import javafx.scene.layout.HBox;
import javafx.scene.layout.VBox;
import javafx.scene.layout.AnchorPane;
import javafx.scene.shape.Circle;
import logic.GameLabyrinth;

import java.net.URL;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Random;
import java.util.ResourceBundle;

public class FXMLDocumentController implements Initializable {

    //<editor-fold defaultstate="collapsed" desc="Instanzen für das Spielfeld">
    @FXML
    private GridPane gridPane;

    @FXML
    private VBox gridVbox;

    @FXML
    private HBox gridHbox;

    @FXML
    private ChoiceBox choiceBox5;

    @FXML
    private AnchorPane anchorPane;

    @FXML
    private Circle aktPlayer1;
    @FXML
    private Circle aktPlayer2;
    @FXML
    private Circle aktPlayer3;
    @FXML
    private Circle aktPlayer4;
    @FXML
    private ImageView field00;
    @FXML
    private ImageView field01;
    @FXML
    private ImageView field03;
    @FXML
    private ImageView field05;
    @FXML
    private ImageView field07;
    @FXML
    private ImageView field08;
    @FXML
    private ImageView field10;
    @FXML
    private ImageView field18;
    @FXML
    private ImageView field30;
    @FXML
    private ImageView field38;
    @FXML
    private ImageView field50;
    @FXML
    private ImageView field58;
    @FXML
    private ImageView field70;
    @FXML
    private ImageView field78;
    @FXML
    private ImageView field80;
    @FXML
    private ImageView field81;
    @FXML
    private ImageView field83;
    @FXML
    private ImageView field85;
    @FXML
    private ImageView field87;
    @FXML
    private ImageView field88;
    @FXML
    private ImageView arrowTopLeft;
    @FXML
    private ImageView arrowTopMiddle;
    @FXML
    private ImageView arrowTopRight;
    @FXML
    private ImageView arrowLeftTop;
    @FXML
    private ImageView arrowLeftMiddle;
    @FXML
    private ImageView arrowLeftDown;
    @FXML
    private ImageView arrowRightTop;
    @FXML
    private ImageView arrowRightMiddle;
    @FXML
    private ImageView arrowRightDown;
    @FXML
    private ImageView arrowDownLeft;
    @FXML
    private ImageView arrowDownMiddle;
    @FXML
    private ImageView arrowDownRight;
    @FXML
    private ImageView field71;
    @FXML
    private ImageView field72;
    @FXML
    private ImageView field73;
    @FXML
    private ImageView field74;
    @FXML
    private ImageView field75;
    @FXML
    private ImageView field76;
    @FXML
    private ImageView field77;
    @FXML
    private ImageView field17;
    @FXML
    private ImageView field27;
    @FXML
    private ImageView field37;
    @FXML
    private ImageView field47;
    @FXML
    private ImageView field57;
    @FXML
    private ImageView field67;
    @FXML
    private ImageView field11;
    @FXML
    private ImageView field21;
    @FXML
    private ImageView field31;
    @FXML
    private ImageView field41;
    @FXML
    private ImageView field51;
    @FXML
    private ImageView field61;
    @FXML
    private ImageView field12;
    @FXML
    private ImageView field22;
    @FXML
    private ImageView field32;
    @FXML
    private ImageView field42;
    @FXML
    private ImageView field52;
    @FXML
    private ImageView field62;
    @FXML
    private ImageView field13;
    @FXML
    private ImageView field23;
    @FXML
    private ImageView field33;
    @FXML
    private ImageView field43;
    @FXML
    private ImageView field53;
    @FXML
    private ImageView field63;
    @FXML
    private ImageView field14;
    @FXML
    private ImageView field24;
    @FXML
    private ImageView field34;
    @FXML
    private ImageView field44;
    @FXML
    private ImageView field54;
    @FXML
    private ImageView field64;
    @FXML
    private ImageView field15;
    @FXML
    private ImageView field25;
    @FXML
    private ImageView field35;
    @FXML
    private ImageView field45;
    @FXML
    private ImageView field55;
    @FXML
    private ImageView field65;
    @FXML
    private ImageView field16;
    @FXML
    private ImageView field26;
    @FXML
    private ImageView field36;
    @FXML
    private ImageView field46;
    @FXML
    private ImageView field56;
    @FXML
    private ImageView field66;
    @FXML
    private ImageView treasure1;
    @FXML
    private ImageView treasure2;
    @FXML
    private ImageView treasure3;
    @FXML
    private ImageView treasure4;
    @FXML
    private ImageView treasure5;
    @FXML
    private ImageView treasure6;
    @FXML
    private ImageView treasure7;
    @FXML
    private ImageView treasure8;
    @FXML
    private ImageView treasure9;
    @FXML
    private ImageView treasure10;
    @FXML
    private ImageView treasure11;
    @FXML
    private ImageView treasure12;
    @FXML
    private ImageView treasure13;
    @FXML
    private ImageView treasure14;
    @FXML
    private ImageView treasure15;
    @FXML
    private ImageView treasure16;
    @FXML
    private ImageView treasure17;
    @FXML
    private ImageView treasure18;
    @FXML
    private ImageView treasure19;
    @FXML
    private ImageView treasure20;
    @FXML
    private ImageView treasure21;
    @FXML
    private ImageView treasure22;
    @FXML
    private ImageView treasure23;
    @FXML
    private ImageView treasure24;

    @FXML
    private Button startBtn;
    @FXML
    private Button exitBtn;
    @FXML
    private Button saveBtn;
    @FXML
    private Button loadBtn;
    @FXML
    private Button newBtn;

    @FXML
    private TextField namePlayer1;
    @FXML
    private TextField namePlayer2;
    @FXML
    private TextField namePlayer3;
    @FXML
    private TextField namePlayer4;
    @FXML
    private Label treasuresYellow;
    @FXML
    private Label treasuresBlue;
    @FXML
    private Label treasuresGreen;
    @FXML
    private Label treasuresRed;
    @FXML
    private ImageView freeWayCard;
    @FXML
    private ChoiceBox choiceBox1;
    @FXML
    private ChoiceBox choiceBox2;
    @FXML
    private ChoiceBox choiceBox3;
    @FXML
    private ChoiceBox choiceBox4;

    private GameLabyrinth game;

    @FXML
    private ImageView[] fieldGamePlay;

    @FXML
    private ImageView[]allField;
    @FXML
    private Image []allFieldPictures;

    private ImageView[][] emptyField;

    private Image[] fieldCards;

    private int[] rotation;

    private ImageView[] treasures;

    private ImageView[] pictureTreasures;

    private int[] schatzanzahl;
    private int[] schatzFelder;

    private int Anzahl;
    private int Spieler;
    private String namePlayer;
    private int Restkarten;
    private String übrigeKarten;

    //</editor-fold>

    /**
     * Initialisiert das Programm
     *
     * @param url
     * @param resourceBundle
     */
    @Override
    public void initialize(URL url, ResourceBundle resourceBundle) {
        
        choiceBox1.getItems().addAll("Normal","KI","KI 2");
        choiceBox1.setValue("Normal");
        choiceBox2.getItems().addAll("Normal","KI","KI 2");
        choiceBox2.setValue("Normal");
        choiceBox3.getItems().addAll("Normal","KI","KI 2");
        choiceBox3.setValue("Normal");
        choiceBox4.getItems().addAll("Normal","KI","KI 2");
        choiceBox4.setValue("Normal");
        choiceBox5.getItems().addAll("1","2","3","4","5","6","7","8","9","10","11","12","13","14","15","16","17","18","19","20","21","22","23","24");
        choiceBox5.setValue("24");


        allField = new ImageView []{
                field00,field01, arrowTopLeft, field03, arrowTopMiddle, field05,arrowTopRight,field07, field08,
                field10,field11, field21, field31, field41, field51, field61, field71,field81,
                arrowLeftTop,field12, field22, field32, field42, field52, field62, field72,arrowRightTop,
                field03,field13, field23, field33, field43, field53, field63, field73,field83,
                arrowLeftMiddle,field14, field24, field34, field44, field54, field64, field74,arrowRightMiddle,
                field05, field15, field25, field35, field45, field55, field65, field75,field85,
                arrowLeftDown,field16, field26, field36, field46, field56, field66, field76,arrowRightDown,
                field07,field17, field27, field37, field47, field57, field67, field77,field87,
                field08, field18, arrowDownLeft, field38, arrowDownMiddle, field58, arrowDownRight, field78, field88,
        };
        allFieldPictures = new Image[]{

        };

        //grdPn width and height both are bound to width of wrapping box
        gridPane.prefWidthProperty().bind(gridVbox.widthProperty());
        gridPane.prefHeightProperty().bind(gridVbox.widthProperty());

        //bind the width of the vBox to the height of the wrapping hBox
        gridVbox.prefWidthProperty().bind(gridHbox.heightProperty());
        //bind the width of the vBox to the height of the wrapping hBox

        for (int i = 0; i < allField.length; i++) {
            allField[i].prefHeight(gridPane.getPrefHeight());
            allField[i].prefWidth(gridPane.getPrefWidth());

        };



        //<editor-fold defaultstate="collapsed" desc="Befüllen des Spielfeldes mit Karten">
        Image iStück = new Image("file:src/gui/pictures/I.png");
        Image tStück = new Image("file:src/gui/pictures/T.png");
        Image lStück = new Image("file:src/gui/pictures/L.png");


        fieldGamePlay = new ImageView[]{
                 field21, field31, field41, field51, field61,
                 field12, field22, field32, field42, field52, field62, field72,
                 field13, field23, field33, field43, field53, field63, field73,
                 field14, field24, field34, field44, field54, field64, field74,
                 field15, field25, field35, field45, field55, field65, field75,
                 field16, field26, field36, field46, field56, field66, field76,
                 field27, field37, field47, field57, field67};

        emptyField = new ImageView[][]{
                {field21,  field41, field61,},
                {field12, field22, field32, field42, field52, field62, field72,},
                {field23,  field43,  field63,},
                { field14, field24, field34, field44, field54, field64, field74, },
                { field25,  field45,  field65,},
                { field16, field26, field36, field46, field56, field66, field76, },
                { field27, field47,  field67, }
        };

        fieldCards = new Image[]{
        iStück,iStück,iStück,iStück,iStück,iStück,iStück,iStück,iStück,iStück,iStück,iStück,iStück,lStück,lStück,lStück,
                lStück,lStück,lStück,lStück,lStück,lStück,lStück,lStück,lStück,lStück,lStück,lStück,tStück,tStück,
                tStück,tStück,tStück,tStück };
        rotation = new int[]{
                90,180,270
        };

        fieldCards = fieldCardsMischen(fieldCards);

        Random ran = new Random();
        int k = 0 + ran.nextInt(2 - 0 + 1);
        int j = 0;
        for (int x =0 ; x < emptyField.length; x++){
            for(int y = 0; y < emptyField[x].length; y++){
                emptyField[x][y].setImage(fieldCards[j]);
                emptyField[x][y].setRotate(rotation[k]);
                j = j+1;
            }
        }
        freeWayCard.setImage(fieldCards[j]);

        //</editor-fold>


    }

    /** Zum Mischen eines Image Arrays
     *
     * @param fieldCards ein Image Array
     * @return das gemischte Image Array
     */
    private Image[] fieldCardsMischen(Image[] fieldCards){
        Image tmp;
        int rand;
        Random r = new Random();
        for (int i = 0; i < fieldCards.length; i++) {
            rand = r.nextInt(fieldCards.length);
            tmp = fieldCards[i];
            fieldCards[i] = fieldCards[rand];
            fieldCards[rand] = tmp;
        }
        return fieldCards;
    }

    /**Zum Mischen eines ImageView Arrays
     *
     * @param fieldCards ImageView Array
     * @return gemischtes ImageView Array
     */
    private ImageView[] fieldMischen(ImageView[] fieldCards){
        ImageView tmp;
        int rand;
        Random r = new Random();
        for (int i = 0; i < fieldCards.length; i++) {
            rand = r.nextInt(fieldCards.length);
            tmp = fieldCards[i];
            fieldCards[i] = fieldCards[rand];
            fieldCards[rand] = tmp;
        }
        return fieldCards;
    }

    /** Mischen eines Integer Arrays
     *
     * @param fieldCards Integer Array
     * @return gemischtes Integer Array
     */
    private int[] zahlenMischen(int[] fieldCards){
        int tmp;
        int rand;
        Random r = new Random();
        for (int i = 0; i < fieldCards.length; i++) {
            rand = r.nextInt(fieldCards.length);
            tmp = fieldCards[i];
            fieldCards[i] = fieldCards[rand];
            fieldCards[rand] = tmp;
        }
        return fieldCards;
    }

    /** Vorbereiten der Grafik bei einem neuen Spielstart
     *
     */
    @FXML
    private void newGame() {
        namePlayer = "namePlayer";
        Anzahl = 0;
        Spieler = 0;
        Restkarten = 0;
        übrigeKarten = "";
        aktPlayer1.setVisible(true);
        aktPlayer2.setVisible(false);
        aktPlayer3.setVisible(false);
        aktPlayer4.setVisible(false);
        namePlayer1.setText(namePlayer1.getText());
        namePlayer1.setEditable(false);
        namePlayer2.setText(namePlayer2.getText());
        namePlayer2.setEditable(false);
        namePlayer3.setText(namePlayer3.getText());
        namePlayer3.setEditable(false);
        namePlayer4.setText(namePlayer4.getText());
        namePlayer4.setEditable(false);
        choiceBox1.setValue(choiceBox1.getValue());
        choiceBox1.setDisable(true);
        choiceBox2.setValue(choiceBox2.getValue());
        choiceBox2.setDisable(true);
        choiceBox3.setValue(choiceBox3.getValue());
        choiceBox3.setDisable(true);
        choiceBox4.setValue(choiceBox4.getValue());
        choiceBox4.setDisable(true);
        choiceBox5.setValue(choiceBox5.getValue());
        choiceBox5.setDisable(true);
        startBtn.setDisable(true);
        Anzahl = Integer.parseInt(choiceBox5.getValue().toString());



        if (!namePlayer1.getText().equals("")){
                Spieler = Spieler +1;
        }
        if (!namePlayer2.getText().equals("")){
            Spieler = Spieler +1;
        }
        if (!namePlayer3.getText().equals("")){
            Spieler = Spieler +1;
        }
        if (!namePlayer4.getText().equals("")){
            Spieler = Spieler +1;
        }

        Anzahl = (Anzahl / Spieler) * Spieler;
        choiceBox5.setValue(Anzahl);
        Restkarten = Anzahl /Spieler;
        if(!namePlayer1.getText().equals("")) {
                        treasuresYellow.setText(String.valueOf(Restkarten));
        }
        if (!namePlayer2.getText().equals("")){
                        treasuresBlue.setText(String.valueOf(Restkarten));
        }
        if (!namePlayer3.getText().equals("")){
                        treasuresGreen.setText(String.valueOf(Restkarten));
        }
        if (!namePlayer4.getText().equals("")){
                        treasuresRed.setText(String.valueOf(Restkarten));
        }

        schatzanzahl = new int []{
                0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23
        };
        schatzFelder = new int[]{
                0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43
        };
        zahlenMischen(schatzanzahl);
        zahlenMischen(schatzFelder);
        fieldMischen(fieldGamePlay);

        treasures = new ImageView[] {
                treasure1,treasure2,treasure3,treasure4,treasure5,treasure6,treasure7,treasure8,treasure9,treasure10,treasure11
                ,treasure12,treasure13,treasure14,treasure15,treasure16,treasure17,treasure18,treasure19,treasure20,treasure21,
                treasure22,treasure23,treasure24
        };
        System.out.println(Anzahl);
        for(int i = 0; i < Anzahl; i++){
            System.out.println(i);
            System.out.println(Anzahl);
            gridPane.add(treasures[schatzanzahl[i]], gridPane.getColumnIndex(fieldGamePlay[i]),gridPane.getRowIndex(fieldGamePlay[i]));

        }
    }

    /**Das Verlassen des Programms
     *
     * @param Event Button ExitGame wird gedrückt
     */
    @FXML
    private void exitGame(ActionEvent Event) {
        Platform.exit();
    }

    /**Spielstand wird aus einer Datei geladen
     *
     * @param Event Button LoadGame
     */
    @FXML
    private void loadGame(ActionEvent Event) {
        throw new UnsupportedOperationException("");
    }

    /**Spielstand in eine Datei speichern
     *
     * @param Event Button SaveGame
     */
    @FXML
    private void saveGame(ActionEvent Event) {
        throw new UnsupportedOperationException("");
    }

    /**Neustart des Spiels durch Säubern der Einträge und Aufrufen von Initialize
     *
     * @param Event Button NewGame
     */
    @FXML
    private void newStart(ActionEvent Event) {

        //Todo Verbessern
        namePlayer1.clear();
        namePlayer1.setEditable(true);
        namePlayer2.clear();
        namePlayer2.setEditable(true);
        namePlayer3.clear();
        namePlayer3.setEditable(true);
        namePlayer4.clear();
        namePlayer4.setEditable(true);
        choiceBox1.setDisable(false);
        choiceBox2.setDisable(false);
        choiceBox3.setDisable(false);
        choiceBox4.setDisable(false);
        choiceBox5.setDisable(false);
        startBtn.setDisable(false);
        aktPlayer1.setVisible(true);
        aktPlayer2.setVisible(true);
        aktPlayer3.setVisible(true);
        aktPlayer4.setVisible(true);
        newGame();
    }
}


